摘要:题目要求思路和代码这是一个简单的双指针问题,即左指针指向可以作为起点的子数组下标,右指针则不停向右移动,将更多的元素囊括进来,从而确保该左右指针内的元素是目标数组的一个兄弟子数组即每个字母的个数均相等左指针记录每个字母出现的次数拷贝一个
题目要求
Given a string s and a non-empty string p, find all the start indices of p"s anagrams in s. Strings consists of lowercase English letters only and the length of both strings s and p will not be larger than 20,100. The order of output does not matter. Example 1: Input: s: "cbaebabacd" p: "abc" Output: [0, 6] Explanation: The substring with start index = 0 is "cba", which is an anagram of "abc". The substring with start index = 6 is "bac", which is an anagram of "abc". Example 2: Input: s: "abab" p: "ab" Output: [0, 1, 2] Explanation: The substring with start index = 0 is "ab", which is an anagram of "ab". The substring with start index = 1 is "ba", which is an anagram of "ab". The substring with start index = 2 is "ab", which is an anagram of "ab".思路和代码
这是一个简单的双指针问题,即左指针指向可以作为起点的子数组下标,右指针则不停向右移动,将更多的元素囊括进来,从而确保该左右指针内的元素是目标数组的一个兄弟子数组(即每个字母的个数均相等)
public ListfindAnagrams(String s, String p) { List result = new ArrayList (); if(p==null || s==null || p.isEmpty() || s.isEmpty()) return result; //左指针 int startIndex = 0; //记录每个字母出现的次数 int[] map = new int[26]; for(char c : p.toCharArray()) { map[c-"a"]++; } char[] sArray = s.toCharArray(); //拷贝一个临时map int[] tmpMap = Arrays.copyOf(map, map.length); for(int i = 0 ; i 0) { tmpMap[index]--; //如果左右指针中数组的长度等于目标数组长度,说明该子数组合法,将左指针加入结果集中 if(i - startIndex + 1 == p.length()) { result.add(startIndex); tmpMap[sArray[startIndex]-"a"]++; startIndex++;//左指针右移一位 } }else if(sArray[startIndex] == sArray[i]){//如果左右指针值相等,则左指针只向右移动一个 startIndex++; }else { //将左指针移动到当前右指针的位置上,因为中间部分的子数组一定无法构成目标数组 startIndex = i--; tmpMap = Arrays.copyOf(map, map.length); } } return result; }
文章版权归作者所有,未经允许请勿转载,若此文章存在违规行为,您可以联系管理员删除。
转载请注明本文地址:https://www.ucloud.cn/yun/74771.html
Problem Given a string s and a non-empty string p, find all the start indices of ps anagrams in s. Strings consists of lowercase English letters only and the length of both strings s and p will not be...
摘要:解题思路,就是只顺序不同但个数相同的字符串,那我们就可以利用的思想来比较每个字符串中字符出现的个数是否相等。 Find All Anagrams in a StringGiven a string s and a non-empty string p, find all the start indices of ps anagrams in s. Strings consists of...
摘要:在线网站地址我的微信公众号完整题目列表从年月日起,每天更新一题,顺序从易到难,目前已更新个题。这是项目地址欢迎一起交流学习。 这篇文章记录我练习的 LeetCode 题目,语言 JavaScript。 在线网站:https://cattle.w3fun.com GitHub 地址:https://github.com/swpuLeo/ca...我的微信公众号: showImg(htt...
摘要:月下半旬攻略道题,目前已攻略题。目前简单难度攻略已经到题,所以后面会调整自己,在刷算法与数据结构的同时,攻略中等难度的题目。 Create by jsliang on 2019-07-30 16:15:37 Recently revised in 2019-07-30 17:04:20 7 月下半旬攻略 45 道题,目前已攻略 100 题。 一 目录 不折腾的前端,和咸鱼有什么区别...
Problem Given an array of strings, group anagrams together. Example: Input: [eat, tea, tan, ate, nat, bat], Output: [ [ate,eat,tea], [nat,tan], [bat] ] Note: All inputs will be in lowercase.The ...
阅读 3547·2021-11-16 11:45
阅读 2049·2021-11-08 13:23
阅读 2188·2021-10-11 10:59
阅读 2874·2021-09-27 13:36
阅读 2468·2019-08-30 15:54
阅读 2644·2019-08-29 16:58
阅读 2763·2019-08-29 16:56
阅读 1322·2019-08-26 13:52